#include "ratemgr.h"
#include "icevo.h"

extern RateMgr *g_InterChrMoveRateMgr;
extern RateMgr *g_InterChrCopyRateMgr;

double InterChrEvolver::GetIntegratedMoveRate() const
	{
	gpos_t Length = GetLength();
	return Length*g_InterChrMoveRateMgr->GetTotalRate();
	}

double InterChrEvolver::GetIntegratedCopyRate() const
	{
	gpos_t Length = GetLength();
	return Length*g_InterChrCopyRateMgr->GetTotalRate();
	}
