#include "stack.h"
#include <signal.h>

extern bool g_ShowProgress;

void OnBreak(int)
	{
	fprintf(stderr, "\nUser break...\n");
	exit(1);
	}

int main(int argc, char *argv[])
	{
	ProcessArgVect(argc, argv);

	g_ShowProgress = !FlagOpt("quiet");
	if (ValueOpt("top"))
		StackTop();
	else if (ValueOpt("split"))
		StackSplit();
	else if (ValueOpt("stats"))
		StackStats();
	else if (ValueOpt("multi"))
		StackMulti();
	else
		Die("Must specify one of -top, -split, -stats or -multi");

	ProgressExit();
	return 0;
	}
