#include "types.h"
#include "align_params.h"

score_t MATCH = 2;
score_t MISMATCH = -6;
score_t GAPOPEN = -12;
score_t GAPEXTEND = -2;
score_t UGAPEXTEND = -1;
score_t MINSCORE = 1;
unsigned SMOOTH = 16;
double MINCOLSCORE = 0.0;

#if	INTEGER_DP
score_t N_SCORE = 0;
#else
score_t N_SCORE = (score_t) -0.1;
#endif

unsigned MINLENGTH = 32;
unsigned MINRADIUS = 4;

coord_t MAXAREA = DEFAULT_MAXLENGTH*DEFAULT_MAXLENGTH;

bool g_PlusOnly = false;
bool g_TopHitOnly = false;
bool g_Pass2 = false;
bool g_AcceptAll = false;
bool g_BandMasked = false;

double g_BandFactor = 2.0;

unsigned SLIDE = 128;
unsigned SLIDEOFF = 64;
unsigned MINBADLENGTH = 32;

ALIGN_METHOD g_AlignMethod = ALIGN_METHOD_Hybrid;
