#if	!defined(  DEF_FAIL) || !defined(  DEF_REJECT) || !defined(  DEF_ACCEPT)
#error "Must #define DEF_FAIL, DEF_REJECT and DEF_ACCEPT"
#endif

DEF_FAIL	(  Copy,			GetRandomPos	)
DEF_FAIL	(  Copy,			PosInRange	)
DEF_FAIL	(  Copy,			RangeExists	)

DEF_FAIL	(  InterChrCopy,	ChrCount )
DEF_FAIL	(  InterChrCopy,	RangeExists )

DEF_FAIL	(  Delete,			GetRandomPos	)
DEF_FAIL	(  Delete,			RangeExists	)

DEF_FAIL	(  Insert,			GetLength	)

DEF_FAIL	(  Insert,			GetRandomPos	)
DEF_FAIL	(  Insert,			RangeExists	)
DEF_FAIL	(  Invert,			GetLength	)
DEF_FAIL	(  Invert,			GetRandomPos	)
DEF_FAIL	(  Invert,			RangeExists	)

DEF_FAIL	(  MEInsert,		GetRandomPos	)

DEF_FAIL	(  Move,			GetMoveLength	)
DEF_FAIL	(  Move,			GetRandomPos	)
DEF_FAIL	(  Move,			PosInRange	)
DEF_FAIL	(  Move,			RangeExists	)

DEF_FAIL	(  InterChrMove,	ChrCount )
DEF_FAIL	(  InterChrMove,	RangeExists )

DEF_FAIL	(  Substitute,		GetRandomPos	)

DEF_FAIL	(  Tandem,			GetTandemLength	)
DEF_FAIL	(  Tandem,			GetRandomPos	)
DEF_FAIL	(  Tandem,			RangeExists	)

DEF_FAIL	(  TandemContract,	GetRandomTandemPos	)
DEF_FAIL	(  TandemContract,	TandemMotifLength	)
DEF_FAIL	(  TandemExpand,	FindMotifStart	)

DEF_FAIL	(  TandemExpand,	GetRandomTandemPos	)
DEF_FAIL	(  TandemExpand,	MotifRangeExists	)

DEF_FAIL	(  CreateCDS,		NoCandidates	)
DEF_FAIL	(  CreateCDS,		NoCDSs	)

DEF_FAIL	(  CreateNontermUTR,		NoCandidates	)

DEF_FAIL	(  CreateTermUTR,		NoCandidates	)

DEF_FAIL	(  DeleteCDS,		NoGenes	)
DEF_FAIL	(  DeleteCDS,		NoCDSs	)

DEF_FAIL	(  DeleteUTR,		NoUTRs	)

DEF_FAIL	(  MoveStartCodonIntoUTR,	NoGenes	)
DEF_FAIL	(  MoveStartCodonIntoUTR,	NoStarts	)

DEF_FAIL	(  MoveStartCodonIntoCDS,	NoGenes	)
DEF_FAIL	(  MoveStartCodonIntoCDS,	NoStarts	)

DEF_FAIL	(  MoveStopCodonIntoCDS,		NoGenes	)
DEF_FAIL	(  MoveStopCodonIntoCDS,		NoStops	)

DEF_FAIL	(  MoveStopCodonIntoUTR,		NoGenes	)
DEF_FAIL	(  MoveStopCodonIntoUTR,		NoCandidates)

DEF_FAIL	(  MoveCDSDonorIntoIntron,	NoGenes	)
DEF_FAIL	(  MoveCDSDonorIntoIntron,	NoDonors)

DEF_FAIL	(  MoveUTRDonorIntoIntron,	NoGenes	)
DEF_FAIL	(  MoveUTRDonorIntoIntron,	NoDonors)

DEF_FAIL	(  MoveCDSAcceptorIntoIntron,	NoGenes	)
DEF_FAIL	(  MoveCDSAcceptorIntoIntron,	NoAcceptors	)

DEF_FAIL	(  MoveUTRAcceptorIntoIntron,	NoGenes	)
DEF_FAIL	(  MoveUTRAcceptorIntoIntron,	NoAcceptors	)

DEF_FAIL	(  MoveAcceptorIntoCDS,	NoGenes	)
DEF_FAIL	(  MoveAcceptorIntoCDS,	NoAcceptors	)

DEF_FAIL	(  MoveAcceptorIntoUTR,	NoGenes	)
DEF_FAIL	(  MoveAcceptorIntoUTR,	NoAcceptors	)

DEF_FAIL	(  MoveDonorIntoCDS,	NoGenes	)
DEF_FAIL	(  MoveDonorIntoCDS,	NoDonors)

DEF_FAIL	(  MoveDonorIntoUTR,	NoGenes	)
DEF_FAIL	(  MoveDonorIntoUTR,	NoDonors)

DEF_FAIL	(  DeleteNGE,		NoNGEs	)

DEF_FAIL	(  DeleteIsland,	NoIslands	)

DEF_FAIL	(  ChangeGeneSpeed,	NoGenes	)

DEF_FAIL	(  ChangeNGESpeed,	NoNGEs	)

DEF_FAIL	(  MoveNGE,			NoNGEs	)
DEF_FAIL	(  MoveNGE,			MaxTries	)

DEF_FAIL	(  MoveIsland,			NoIslands	)
DEF_FAIL	(  MoveIsland,			MaxTries	)

DEF_FAIL	(  CreateNGE,		NoNGEs	)
DEF_FAIL	(  CreateNGE,		MaxTries	)

DEF_FAIL	(  CreateIsland,	NoIslands	)
DEF_FAIL	(  CreateIsland,	MaxTries	)

DEF_FAIL	(  CreateNXE,		NoNXEs	)
DEF_FAIL	(  CreateNXE,		MaxTries	)
DEF_FAIL	(  CreateNXE,		NoCandidates	)

DEF_FAIL	(  DeleteNXE,		NoCandidates	)

DEF_FAIL	(  MoveNXE,			NoCandidates	)
DEF_FAIL	(  MoveNXE,			MaxTries	)

DEF_FAIL	(  MoveUTRTerm,		NoCandidates	)

DEF_FAIL	(  RecipTransloc,	MinL	)
DEF_FAIL	(  NonRecipTransloc,	MinL	)

DEF_REJECT	(  Copy,			InsStopCodon	)
DEF_REJECT	(  Copy,			InsEndOfSeq	)
DEF_REJECT	(  Copy,			InsAccProb	)
DEF_REJECT	(  Copy,			InsCDSMod3	)
DEF_REJECT	(  Copy,			InsCreatesSTOP	)
DEF_REJECT	(  Copy,			InsInSTARTorSTOP	)

DEF_REJECT	(  InterChrCopy,	Insert	)

DEF_REJECT	(  Delete,			DelCDSMod3	)
DEF_REJECT	(  Delete,			DelNotAllCDS	)
DEF_REJECT	(  Delete,			DelCodonDel	)
DEF_REJECT	(  Delete,			DelHasSTOP )
DEF_REJECT	(  Delete,			DelHasSTART )
DEF_REJECT	(  Delete,			DelCreatesSTOP )
DEF_REJECT	(  Delete,			DelAccProb )
DEF_REJECT	(  Delete,			DelIntronLength )
DEF_REJECT	(  Delete,			DelTwoGenes )
DEF_REJECT	(  Delete,			DelSplice )
DEF_REJECT	(  Delete,			DelEndOfSeq )

DEF_REJECT	(  Insert,			InsStopCodon	)
DEF_REJECT	(  Insert,			InsEndOfSeq	)
DEF_REJECT	(  Insert,			InsAccProb	)
DEF_REJECT	(  Insert,			InsCDSMod3	)
DEF_REJECT	(  Insert,			InsCreatesSTOP	)
DEF_REJECT	(  Insert,			InsInSTARTorSTOP	)

DEF_REJECT	(  MEInsert,		InsStopCodon	)
DEF_REJECT	(  MEInsert,		InsEndOfSeq	)
DEF_REJECT	(  MEInsert,		InsAccProb	)
DEF_REJECT	(  MEInsert,		InsCDSMod3	)
DEF_REJECT	(  MEInsert,		InsCreatesSTOP	)
DEF_REJECT	(  MEInsert,		InsInSTARTorSTOP	)

DEF_REJECT	(  Invert,			PartialCE )
DEF_REJECT	(  Invert,			GeneCE )
DEF_REJECT	(  Invert,			PartialGene )

DEF_REJECT	(  Move,			PartialCE	)
DEF_REJECT	(  Move,			PartialGene	)
DEF_REJECT	(  Move,			GeneIntoGene  )
DEF_REJECT	(  Move,			CEIntoGene  )
DEF_REJECT	(  Move,			InsIntoCE  )

DEF_REJECT	(  InterChrMove,			PartialCE	)
DEF_REJECT	(  InterChrMove,			PartialGene	)
DEF_REJECT	(  InterChrMove,			GeneIntoGene  )
DEF_REJECT	(  InterChrMove,			CEIntoGene  )
DEF_REJECT	(  InterChrMove,			InsIntoCE  )

DEF_REJECT	(  Substitute,		CodingConstraint	)
DEF_REJECT	(  Substitute,		Substitute	)
DEF_FAIL	(  Substitute,		GCReject	)
DEF_FAIL	(  Substitute,		ATReject	)

DEF_REJECT	(  Tandem,			InvertCDS	)
DEF_REJECT	(  Tandem,			InsStopCodon	)
DEF_REJECT	(  Tandem,			InsEndOfSeq	)
DEF_REJECT	(  Tandem,			InsAccProb	)
DEF_REJECT	(  Tandem,			InsCDSMod3	)
DEF_REJECT	(  Tandem,			InsCreatesSTOP	)
DEF_REJECT	(  Tandem,			InsInSTARTorSTOP	)

DEF_REJECT	(  TandemContract,	Delete	)

DEF_REJECT	(  TandemExpand,	InsEndOfSeq	)
DEF_REJECT	(  TandemExpand,	InsAccProb	)
DEF_REJECT	(  TandemExpand,	InsCDSMod3	)
DEF_REJECT	(  TandemExpand,	InsCreatesSTOP	)
DEF_REJECT	(  TandemExpand,	InsInSTARTorSTOP	)

DEF_REJECT	(  ChrFuse,			ChrCount	)
DEF_REJECT	(  ChrFuse,			ChrLength	)

DEF_REJECT	(  ChrSplit,		ChrCount	)
DEF_REJECT	(  ChrSplit,		ChrLength	)
DEF_REJECT	(  ChrSplit,		InGene	)
DEF_REJECT	(  ChrSplit,		Insert	)

DEF_REJECT	(  RecipTransloc,		PosInGene	)
DEF_REJECT	(  RecipTransloc,		ChrCount	)

DEF_REJECT	(  NonRecipTransloc,		PosInGene	)
DEF_REJECT	(  NonRecipTransloc,		ChrCount	)

DEF_ACCEPT	(  Copy	)
DEF_ACCEPT	(  InterChrCopy	)
DEF_ACCEPT	(  Delete	)
DEF_ACCEPT	(  Insert	)
DEF_ACCEPT	(  Invert	)
DEF_ACCEPT	(  Move	)
DEF_ACCEPT	(  InterChrMove	)
DEF_ACCEPT	(  Substitute	)
DEF_ACCEPT	(  Tandem	)
DEF_ACCEPT	(  TandemContract	)
DEF_ACCEPT	(  TandemExpand	)
DEF_ACCEPT	(  MEInsert	)
DEF_ACCEPT	(  ChrSplit	)
DEF_ACCEPT	(  ChrFuse	)
DEF_ACCEPT	(  RecipTransloc	)
DEF_ACCEPT	(  NonRecipTransloc	)
DEF_ACCEPT	(  DeleteUTR )
DEF_ACCEPT	(  CreateNontermUTR )
DEF_ACCEPT	(  CreateTermUTR )
DEF_ACCEPT	(  DeleteCDS )
DEF_ACCEPT	(  CreateCDS )
DEF_ACCEPT	(  MoveStartCodonIntoUTR )
DEF_ACCEPT	(  MoveStopCodonIntoUTR )
DEF_ACCEPT	(  MoveStartCodonIntoCDS )
DEF_ACCEPT	(  MoveStopCodonIntoCDS )
DEF_ACCEPT	(  MoveCDSDonorIntoIntron )
DEF_ACCEPT	(  MoveUTRDonorIntoIntron )
DEF_ACCEPT	(  MoveDonorIntoCDS )
DEF_ACCEPT	(  MoveDonorIntoUTR )
DEF_ACCEPT	(  MoveCDSAcceptorIntoIntron )
DEF_ACCEPT	(  MoveUTRAcceptorIntoIntron )
DEF_ACCEPT	(  MoveAcceptorIntoCDS )
DEF_ACCEPT	(  MoveAcceptorIntoUTR )
DEF_ACCEPT	(  DeleteNGE )
DEF_ACCEPT	(  MoveNGE )
DEF_ACCEPT	(  CreateNGE )
DEF_ACCEPT	(  DeleteNXE )
DEF_ACCEPT	(  MoveNXE )
DEF_ACCEPT	(  CreateNXE )
DEF_ACCEPT	(  MoveUTRTerm )
DEF_ACCEPT	(  ChangeGeneSpeed )
DEF_ACCEPT	(  ChangeNGESpeed )
DEF_ACCEPT	(  CreateIsland )
DEF_ACCEPT	(  DeleteIsland )
DEF_ACCEPT	(  MoveIsland )

#undef DEF_FAIL
#undef DEF_REJECT
#undef DEF_ACCEPT
