#ifndef evoassert_h
#define evoassert_h

#undef  assert
#undef  asserta
#undef  myassert

#ifdef  __cplusplus
extern "C" {
#endif

void myassertfail(const char *, const char *, unsigned);

#ifdef  __cplusplus
}
#endif

#ifdef  NDEBUG

#define assert(exp)     ((void)0)
#define myassert(exp)     ((void)0)

#else

#define assert(exp) (void)( (exp) || (myassertfail(#exp, __FILE__, __LINE__), 0) )
#define myassert(exp) (void)( (exp) || (myassertfail(#exp, __FILE__, __LINE__), 0) )

#endif  // NDEBUG

#define asserta(exp) (void)( (exp) || (Die("%s(%u) Assertion failed: %s", __FILE__, __LINE__, #exp), 0) )

#endif // evoassert_h
