#include "getopts.h"
#include "utils.h"
#include "revfile.h"
#include "progress.h"

extern bool g_ShowProgress;

void Glover();
void GlobalOverlapStats();
void HighCopyCountFilter();

int main(int argc, char **argv)
	{
	ProcessArgVect(argc, argv);

	g_ShowProgress = !FlagOpt("quiet");

	if (ValueOpt("stats"))
		{
		GlobalOverlapStats();
		return 0;
		}
	else if (ValueOpt("hcc"))
		{
		HighCopyCountFilter();
		return 0;
		}

	Glover();
	return 0;
	}
