#include "utils.h"
#include <string>

void MakeAln(const char *A, unsigned LA, const char *B,
  unsigned LB, const std::string &ssPath, std::string &Row1,
  std::string &Row2)
	{
	unsigned i = 0;
	const char *Path_ = ssPath.c_str();
	const char *Path = Path_;

// performance optimization
	unsigned MaxLen = std::max(LA, LB);
	Row1.reserve(2*MaxLen);
	Row2.reserve(2*MaxLen);

	while (char c = *Path++)
		{
		switch (c)
			{
		case 'M':
		case 'D':
			Row1.push_back(A[i++]);
			break;

		case 'I':
			Row1.push_back('-');
			break;

		default:
			assert(false);
			}
		}
	assert(i == LA);

	unsigned j = 0;
	Path = Path_;
	while (char c = *Path++)
		{
		switch (c)
			{
		case 'M':
		case 'I':
			Row2.push_back(B[j++]);
			break;

		case 'D':
			Row2.push_back('-');
			break;

		default:
			assert(false);
			}
		}
	assert(j == LB);
	assert(Row1.size() == Row2.size());
	}
