#include "evolver.h"
#include "ratemgr.h"

EVENT_RESULT Evolver::Try_TandemContract()
	{
	gpos_t Pos = GetRandomTandemPos();
	if (Pos == GPOS_T_MAX)
		EV_FAILN(TandemContract, GetRandomTandemPos)

	gpos_t TandemMotifLength = GetTandemMotifLength(Pos);
	if (!RangeExists(Pos, TandemMotifLength))
		EV_FAILN(TandemContract, TandemMotifLength)

	bool Accept = AcceptDelete(Pos, TandemMotifLength);
	if (!Accept)
		EV_REJECT(TandemContract, TandemMotifLength, Delete)

	m_CurrentEventPos = Pos;
	Delete(Pos, TandemMotifLength);

	RecomputeTandemRates();
	EV_ACCEPT(TandemContract, Pos, TandemMotifLength)
	}
