#include "utils.h"

const unsigned BLOCK_SIZE = 60;

void WriteFasta(FILE *f, const char *SeqData, unsigned Length)
	{
	for (unsigned Pos = 0; Pos < Length; Pos += BLOCK_SIZE)
		{
		unsigned Bytes = Length - Pos;
		if (Bytes > BLOCK_SIZE)
			Bytes = BLOCK_SIZE;
		WriteStdioFile(f, SeqData + Pos, Bytes);
		WriteStdioFileStr(f, "\n");
		}
	}
