#include "utils.h"

void WriteGFFRecord(FILE *f, const char *Label, const char *RecType,
  coord_t lo, coord_t hi, ai_score_t Score, char Strand, const char *Attrs)
	{
	if (f == 0)
		Die("WriteGFFRecord: file not open");

	fprintf(f, "%s\t%s\t%s\t%u\t%u\t%s\t%c\t.\t",
		Label,
		"revolver",
		RecType,
		(unsigned) (lo + 1),
		(unsigned) (hi + 1),
		AIScoreToStr(Score),
		Strand);

	if (Attrs != 0)
		fprintf(f, "%s", Attrs);

	fprintf(f, "\n");
	}
