#include "evo.h"

void DumpChrNames()
	{
	const char *FileName = RequiredValueOpt("dumpchrnames");
	FILE *f = OpenStdioFile(FileName);

	EvoFileHeader Hdr;
	vector<MULIndexEntryData> IEs;
	GenInfo Genome;
	ReadEvoIndex(f, Hdr, IEs, Genome, true);

	unsigned ChrCount = Genome.GetChrCount();
	for (unsigned ChrIndex = 0; ChrIndex < ChrCount; ++ChrIndex)
		{
		const ChrInfo &CI = Genome.GetChrInfo(ChrIndex);
		Dump("%s\n", CI.GetName().c_str());
		}
	}
