#ifndef bp_h
#define bp_h

struct BendPoint
	{
	coord_t Pos;
	bool lo;
	unsigned RecIndex;
	unsigned FileIndex;

	BendPoint()
		{
		Pos = COORD_T_MAX;
		lo = false;
		RecIndex = UINT_MAX;
		FileIndex = UINT_MAX;
		}

	bool operator<(const BendPoint &rhs) const
		{
		if (Pos != rhs.Pos)
			return Pos < rhs.Pos;
		if (lo != rhs.lo)
			return !lo;
		return false;
		}
	};

#endif // bp_h
