#include "revfile.h"
#include "evolver.h"
#include "evomodel.h"

extern RevFile *g_AlnRev;

unsigned g_ShortAlnCount;
unsigned g_AlnCount;

void GotAlignment(const Evolver &/*Evo*/, const AlnInfo &AI,
  const StdStrVec &Rows)
	{
	if (SIZE(Rows[0]) < P_MinAlnLength)
		{
		++g_ShortAlnCount;
		return;
		}
	++g_AlnCount;

	g_AlnRev->AddAln(AI, Rows);
	}
