#ifndef PROGRESS_H
#define PROGRESS_H

/* Requires this for FILE */
#include <stdio.h>

void SetLogProgress(bool On);
void ShowProgress(bool Show);
void PushShowProgress(bool Show);
void PopShowProgress();
void Progress(const char *Format, ...);
void ProgressNoRes(const char *Format, ...);
void ProgressStart(const char *Format, ...);
void ProgressStartFile(FILE *f, const char *Format, ...);
void SetProgressMsg(const char *Format, ...);
void ProgressStep(int StepIndex, int StepCount);
void ProgressStepFile();
void ProgressDone();
void ProgressExit();
unsigned GetProgressDepth();

extern bool g_ShowProgress;

#endif // PROGRESS_H
