#include "utils.h"
#include "evolver.h"
#include "myrand.h"

EVENT_RESULT Evolver::Try_DeleteIsland()
	{
	vector<gpos_t> Starts;
	vector<gpos_t> Lengths;
	GetIslands(m_FirstEvolvedPos, UINT32_MAX, Starts, Lengths);
	unsigned N = SIZE(Starts);
	asserta(SIZE(Lengths) == N);
	if (N == 0)
		EV_FAILN(DeleteIsland, NoIslands);

	unsigned r = RandInt(N);
	gpos_t Start = Starts[r];
	gpos_t Length = Lengths[r];
	m_CurrentEventPos = Start;
	SetIsland(Start, Length, false);

	EV_ACCEPTN(DeleteIsland, Start);
	}
